Package com.io7m.idstore.error_codes

# Class IdException

java.lang.Object
java.lang.Throwable
java.lang.Exception
com.io7m.idstore.error_codes.IdException

All Implemented Interfaces:
  `com.io7m.seltzer.api.SStructuredErrorExceptionType<IdErrorCode>`, `com.io7m.seltzer.api.SStructuredErrorType<IdErrorCode>`, `Serializable`

Direct Known Subclasses:
  `IdAClientException`, `IdCommandExecutionFailure`, `IdDatabaseException`, `IdHTTPErrorStatusException`, `IdPasswordException`, `IdProtocolException`, `IdRequestLimitExceeded`, `IdSecurityException`, `IdServerException`, `IdUClientException`

public class IdException extends Exception implements com.io7m.seltzer.api.SStructuredErrorExceptionType<IdErrorCode>
The base type of exceptions.

See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IdException(String message, IdErrorCode inErrorCode, Map<String,String> inAttributes, Optional<String> inRemediatingAction)`
  Construct an exception.
  `IdException(String message, Throwable cause, IdErrorCode inErrorCode, Map<String,String> inAttributes, Optional<String> inRemediatingAction)`
  Construct an exception.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final Map<String,String>`
  `attributes()`
  `final IdErrorCode`
  `errorCode()`
  `final Optional<Throwable>`
  `exception()`
  `final Optional<String>`
  `remediatingAction()`

  ### Methods inherited from class java.lang.Throwable

  `addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.seltzer.api.SStructuredErrorExceptionType

  `getMessage, message`

- ## Constructor Details

  - ### IdException

    public IdException(String message, IdErrorCode inErrorCode, Map<String,String> inAttributes, Optional<String> inRemediatingAction)
    Construct an exception.
    Parameters:
      `message` - The message
      `inErrorCode` - The error code
      `inAttributes` - The error attributes
      `inRemediatingAction` - The remediating action, if any

  - ### IdException

    public IdException(String message, Throwable cause, IdErrorCode inErrorCode, Map<String,String> inAttributes, Optional<String> inRemediatingAction)
    Construct an exception.
    Parameters:
      `message` - The message
      `cause` - The cause
      `inErrorCode` - The error code
      `inAttributes` - The error attributes
      `inRemediatingAction` - The remediating action, if any

- ## Method Details

  - ### errorCode

    public final IdErrorCode errorCode()
    Specified by:
      `errorCode` in interface `com.io7m.seltzer.api.SStructuredErrorType<IdErrorCode>`

  - ### attributes

    public final Map<String,String> attributes()
    Specified by:
      `attributes` in interface `com.io7m.seltzer.api.SStructuredErrorType<IdErrorCode>`

  - ### remediatingAction

    public final Optional<String> remediatingAction()
    Specified by:
      `remediatingAction` in interface `com.io7m.seltzer.api.SStructuredErrorType<IdErrorCode>`

  - ### exception

    public final Optional<Throwable> exception()
    Specified by:
      `exception` in interface `com.io7m.seltzer.api.SStructuredErrorType<IdErrorCode>`